<?php
class CarWashException extends Exception {}

class CarWash {
    protected $programmes = array();

    public function addProgramme($name, $commands) {
        $this->programmes[$name] = $commands;
    }

    public function wash($programme, Vehicle $vehicle) {
        if (!isset($this->programmes[$programme])) {
            throw new CarWashException("Das Waschprogramm {$programme} existiert nicht.");
        }
        print "Waschprogramm {$programme} wird gestartet.\n";
        foreach ($this->programmes[$programme] as $command) {
            $command->execute($vehicle);
        }
    }
}
?>