<?php
require_once 'Car.php';

class IOException extends Exception {}
class IndexOutOfBoundsException extends Exception {}

class CarList {

    protected $carDefinitions = array();
    protected $cars = array();

    public function __construct($csvFile) {
        if (!file_exists($csvFile)) {
            throw new IOException();
        }
        $fp = fopen($csvFile, 'r');
        while (false !== $line = fgetcsv($fp, 1024, ';')) {
            $this->carDefinitions[] = array(
                                        'manufacturer' => $line[0],
                                        'color'        => $line[1],
                                        'milage'       => $line[2],
                                      );
        }
    }

    public function countCars() {
        return count($this->carDefinitions);
    }

    public function getCar($pos) {
        if ($pos >= count($this->carDefinitions)) {
            throw new IndexOutOfBoundsException();
        }
        if (!isset($this->cars[$pos])) {
            $this->cars[$pos] = new Car($this->carDefinitions[$pos]['manufacturer'],
                                        $this->carDefinitions[$pos]['color'],
                                        $this->carDefinitions[$pos]['milage']);
        }
        return $this->cars[$pos];
    }
}