<?php
require_once 'Car.php';

class IOException extends Exception {}

class CarList implements Iterator {

    protected $carDefinitions = array();
    protected $cars = array();

    protected $pos = 0;

    public function __construct($csvFile) {
        if (!file_exists($csvFile)) {
            throw new IOException();
        }
        $fp = fopen($csvFile, 'r');
        while (false !== $line = fgetcsv($fp, 1024, ';')) {
            $this->carDefinitions[] = array(
                                        'manufacturer' => $line[0],
                                        'color'        => $line[1],
                                        'milage'       => $line[2],
                                      );
        }
    }

    public function rewind() {
        $this->pos = 0;
    }

    public function key() {
        return $this->pos;
    }

    public function next() {
        $this->pos++;
    }

    public function valid() {
        if ($this->pos < count($this->carDefinitions)) {
            return true;
        }
        return false;
    }

    public function current() {
        if (!isset($this->cars[$this->pos])) {
            $this->cars[$this->pos] = new Car($this->carDefinitions[$this->pos]['manufacturer'],
                                              $this->carDefinitions[$this->pos]['color'],
                                              $this->carDefinitions[$this->pos]['milage']);
        }
        return $this->cars[$this->pos];
    }
}