<?php
require_once 'Observer.php';

class RegularInspectionObserver implements Observer {

    private $nextInspection = null;
    private $interval;

    public function __construct($startAt, $interval) {
        $this->nextInspection = $startAt;
        $this->interval = $interval;
    }

    public function update(Observable $vehicle) {
        if (!$vehicle instanceof Vehicle) {
            return;
        }
        if ($vehicle->getMilage() >= $this->nextInspection) {
            $vehicle->inspect();
            $this->nextInspection = $this->nextInspection + $this->interval;
        }
    }
}
?>