<?php
require_once 'PurchasingFacade.php';
require_once 'Customer.php';

$company = new RentalCompany(new DebuggerEcho());
$bmwManufacturer = new CarManufacturer('BMW');
$peugeotManufacturer = new ConvertibleManufacturer('Peugeot');

$facade = new PurchasingFacade($company);
$facade->addManufacturer('bmw', $bmwManufacturer);
$facade->addManufacturer('peugeot', $peugeotManufacturer);

$bmw     = $facade->purchase('bmw', 'blau');
$peugeot = $facade->purchase('peugeot', 'rot');

$schst = new Customer('schst', 'Stephan Schmidt');
$gerd = new Customer('gerd', 'Gerd Schaufelberger');

$company->rentVehicle($bmw, $schst);
sleep(3);
$company->returnVehicle($bmw);
sleep(2);
$company->rentVehicle($peugeot, $schst);
sleep(1);
$company->rentVehicle($bmw, $gerd);
sleep(4);
$company->returnVehicle($bmw);
?>