<?php
require_once 'Visitor.php';
class XMLExportVisitor implements Visitor {

    protected $doc;
    protected $root;
    protected $currentAction = null;

    public function __construct() {
        $this->doc = new DOMDocument('1.0', 'iso-8859-1');
        $this->doc->formatOutput = true;
    }

    public function visitRentalCompany(RentalCompany $company) {
        $this->root = $this->doc->createElement('rentalCompany');
        $this->doc->appendChild($this->root);
    }

    public function visitRentalAction(RentalAction $action) {
        $this->currentAction = $this->doc->createElement('rentalAction');
        $this->root->appendChild($this->currentAction);
        $this->currentAction->setAttribute('rentDate', $action->getRentDate());
        if ($action->isReturned()) {
            $this->currentAction->setAttribute('returnDate', $action->getReturnDate());
        }
    }

    public function visitVehicle(Vehicle $vehicle) {
        $tag = $this->doc->createElement('vehicle');
        $tag->setAttribute('manufacturer', $vehicle->getManufacturer());
        $tag->setAttribute('color', $vehicle->getColor());
        $this->currentAction->appendChild($tag);
    }

    public function visitCustomer(Customer $customer) {
        $tag = $this->doc->createElement('customer');
        $tag->setAttribute('id', $customer->getId());
        $tag->setAttribute('name', $customer->getName());
        $this->currentAction->appendChild($tag);
    }

    public function asXML() {
        return $this->doc->saveXML();
    }
}
?>